Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 4647)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 4648)
@@ -425,62 +400,58 @@
        dz_stretched = dz(1)
 
-!--    The default value of dz_stretch_level_start is negative, thus the first
-!--    condition is true even if no stretching shall be applied. Hence, the 
-!--    second condition is also necessary.
+!--    The default value of dz_stretch_level_start is negative, thus the first condition is true
+!--    even if no stretching shall be applied. Hence, the second condition is also necessary.
        DO  k = 2, nzt+1-symmetry_flag
-          IF ( dz_stretch_level_start(n) <= zu(k-1) .AND.                      &
-               dz_stretch_level_start(n) /= -9999999.9_wp ) THEN
+          IF ( dz_stretch_level_start(n) <= zu(k-1)  .AND.                                         &
+               dz_stretch_level_start(n) /= -9999999.9_wp )  THEN
              dz_stretched = dz_stretched * dz_stretch_factor_array(n)
-             
-             IF ( dz(n) > dz(n+1) ) THEN
+
+             IF ( dz(n) > dz(n+1) )  THEN
                 dz_stretched = MAX( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (higher) dz
              ELSE
                 dz_stretched = MIN( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (lower) dz
              ENDIF
-             
-             IF ( dz_stretch_level_start_index(n) == nzt+1 )                         &
-             dz_stretch_level_start_index(n) = k-1
-             
-          ENDIF
-          
+
+             IF ( dz_stretch_level_start_index(n) == nzt+1 )  dz_stretch_level_start_index(n) = k-1
+
+          ENDIF
+
           zu(k) = zu(k-1) + dz_stretched
-          
-!
-!--       Make sure that the stretching ends exactly at dz_stretch_level_end 
-          dz_level_end = ABS( zu(k) - dz_stretch_level_end(n) ) 
-          
-          IF ( dz_level_end  < dz(n+1)/3.0 ) THEN
+
+!
+!--       Make sure that the stretching ends exactly at dz_stretch_level_end
+          dz_level_end = ABS( zu(k) - dz_stretch_level_end(n) )
+
+          IF ( dz_level_end  < dz(n+1)/3.0 )  THEN
              zu(k) = dz_stretch_level_end(n)
              dz_stretched = dz(n+1)
              dz_stretch_level_end_index(n) = k
-             n = n + 1             
+             n = n + 1
           ENDIF
        ENDDO
-       
-!
-!--    If a closed channel flow is simulated, make sure that grid structure is  
-!--    the same for both bottom and top boundary. (Hint: Using a different dz 
-!--    at the bottom and at the top makes no sense due to symmetric boundaries
-!--    where dz should be equal. Therefore, different dz at the bottom and top  
-!--    causes an abort (see check_parameters).)
-       IF ( topography == 'closed_channel' ) THEN
+
+!
+!--    If a closed channel flow is simulated, make sure that grid structure is the same for both
+!--    bottom and top boundary. (Hint: Using a different dz at the bottom and at the top makes no
+!--    sense due to symmetric boundaries where dz should be equal. Therefore, different dz at the
+!--    bottom and top causes an abort (see check_parameters).)
+       IF ( topography == 'closed_channel' )  THEN
           zu(nzt+1) = zu(nzt) + dz(1) * 0.5_wp
        ENDIF
 
 !
-!--    Compute the w-levels. They are always staggered half-way between the 
-!--    corresponding u-levels. In case of dirichlet bc for u and v at the 
-!--    ground the first u- and w-level (k=0) are defined at same height (z=0). 
-!--    Per default, the top w-level is extrapolated linearly. In case of 
-!--    a closed channel flow, zu(nzt+1) and zw(nzt) must be set explicitely.
-!--    (Hint: Using a different dz at the bottom and at the top makes no sense
-!--    due to symmetric boundaries where dz should be equal. Therefore, 
-!--    different dz at the bottom and top causes an abort (see 
-!--    check_parameters).)
+!--    Compute the w-levels. They are always staggered half-way between the corresponding u-levels.
+!--    In case of dirichlet bc for u and v at the ground the first u- and w-level (k=0) are defined
+!--    at same height (z=0).
+!--    Per default, the top w-level is extrapolated linearly. In case of a closed channel flow,
+!--    zu(nzt+1) and zw(nzt) must be set explicitely.
+!--    (Hint: Using a different dz at the bottom and at the top makes no sense due to symmetric
+!--    boundaries where dz should be equal. Therefore, different dz at the bottom and top causes an
+!--    abort (see check_parameters).)
        zw(0) = 0.0_wp
        DO  k = 1, nzt-symmetry_flag
           zw(k) = ( zu(k) + zu(k+1) ) * 0.5_wp
        ENDDO
-       IF ( topography == 'closed_channel' ) THEN
+       IF ( topography == 'closed_channel' )  THEN
           zw(nzt)   = zw(nzt-1) + dz(1)
           zw(nzt+1) = zw(nzt) + dz(1)
@@ -492,60 +463,54 @@
 
 !
-!--    The stretching region has to be large enough to allow for a smooth
-!--    transition between two different grid spacings. The number 4 is an
-!--    empirical value
+!--    The stretching region has to be large enough to allow for a smooth transition between two
+!--    different grid spacings. The number 4 is an empirical value
        DO n = 1, number_stretch_level_start
-          min_dz_stretch_level_end(n) = dz_stretch_level_start(n) -            &
-                                        4 * MAX( dz(n),dz(n+1) )
+          min_dz_stretch_level_end(n) = dz_stretch_level_start(n) - 4 * MAX( dz(n),dz(n+1) )
        ENDDO
-       
-       IF ( ANY( min_dz_stretch_level_end (1:number_stretch_level_start) <     &
-                 dz_stretch_level_end(1:number_stretch_level_start) ) ) THEN
-             message_string= 'Each dz_stretch_level_end has to be less ' //   &
-                             'than its corresponding value for &' //           &
-                             'dz_stretch_level_start - 4*MAX(dz(n),dz(n+1)) '//&
+
+       IF ( ANY( min_dz_stretch_level_end (1:number_stretch_level_start) <                         &
+                 dz_stretch_level_end(1:number_stretch_level_start) ) )  THEN
+             message_string= 'Each dz_stretch_level_end has to be less ' //                        &
+                             'than its corresponding value for &' //                               &
+                             'dz_stretch_level_start - 4*MAX(dz(n),dz(n+1)) '//                    &
                              'to allow for smooth grid stretching'
              CALL message( 'init_grid', 'PA0224', 1, 2, 0, 6, 0 )
        ENDIF
-       
-!
-!--    Stretching must not be applied close to the surface (last two grid 
-!--    points). For the default case dz_stretch_level_start is negative. 
-       IF ( ANY( dz_stretch_level_start >= - dz(1) * 1.5_wp ) ) THEN
-          WRITE( message_string, * ) 'Each dz_stretch_level_start has to be ',&
-                                     'less than ', -dz(1) * 1.5
+
+!
+!--    Stretching must not be applied close to the surface (last two grid points). For the default
+!--    case dz_stretch_level_start is negative.
+       IF ( ANY( dz_stretch_level_start >= - dz(1) * 1.5_wp ) )  THEN
+          WRITE( message_string, * )  'Each dz_stretch_level_start has to be ',                    &
+                                      'less than ', -dz(1) * 1.5
              CALL message( 'init_grid', 'PA0226', 1, 2, 0, 6, 0 )
        ENDIF
 
 !
-!--    The stretching has to start and end on a grid level. Therefore 
-!--    user-specified values are mapped to the next highest level. The  
-!--    calculation of the first level is realized differently just because of 
-!--    historical reasons (the advanced/new stretching mechanism was realized  
-!--    in a way that results don't change if the old parameters 
-!--    dz_stretch_level, dz_stretch_factor and dz_max are used)
-       IF ( number_stretch_level_start /= 0 ) THEN
-          dz_stretch_level_start(1) = INT( (dz_stretch_level_start(1) +        &
-                                            dz(1)/2.0) / dz(1) )               &
+!--    The stretching has to start and end on a grid level. Therefore user-specified values are
+!--    mapped to the next highest level. The calculation of the first level is realized differently
+!--    just because of historical reasons (the advanced/new stretching mechanism was realized in a
+!--    way that results don't change if the old parameters dz_stretch_level, dz_stretch_factor and
+!--    dz_max are used)
+       IF ( number_stretch_level_start /= 0 )  THEN
+          dz_stretch_level_start(1) = INT( (dz_stretch_level_start(1) + dz(1)/2.0) / dz(1) )       &
                                       * dz(1) - dz(1)/2.0
        ENDIF
-       
-       IF ( number_stretch_level_start > 1 ) THEN
+
+       IF ( number_stretch_level_start > 1 )  THEN
           DO n = 2, number_stretch_level_start
-             dz_stretch_level_start(n) = INT( dz_stretch_level_start(n) /      &
-                                              dz(n) ) * dz(n)
-          ENDDO
-       ENDIF
-       
-       IF ( number_stretch_level_end /= 0 ) THEN
+             dz_stretch_level_start(n) = INT( dz_stretch_level_start(n) / dz(n) ) * dz(n)
+          ENDDO
+       ENDIF
+
+       IF ( number_stretch_level_end /= 0 )  THEN
           DO n = 1, number_stretch_level_end
-             dz_stretch_level_end(n) = INT( dz_stretch_level_end(n) /          &
-                                            dz(n+1) ) * dz(n+1)
-          ENDDO
-       ENDIF
-       
+             dz_stretch_level_end(n) = INT( dz_stretch_level_end(n) / dz(n+1) ) * dz(n+1)
+          ENDDO
+       ENDIF
+
 !
 !--    Determine stretching factor if necessary
-       IF ( number_stretch_level_end >= 1 ) THEN 
+       IF ( number_stretch_level_end >= 1 ) THEN
           CALL calculate_stretching_factor( number_stretch_level_end )
        ENDIF
@@ -553,7 +518,7 @@
 !
 !--    Grid for ocean with free water surface is at k=nzt (w-grid).
-!--    In case of neumann bc at the ground the first first u-level (k=0) lies
-!--    below the first w-level (k=0). In case of dirichlet bc the first u- and
-!--    w-level are defined at same height, but staggered from the second level.
+!--    In case of neumann bc at the ground the first first u-level (k=0) lies below the first
+!--    w-level (k=0). In case of dirichlet bc the first u- and w-level are defined at same height,
+!--    but staggered from the second level.
 !--    The second u-level (k=1) corresponds to the top of the surface layer.
 !--    z values are negative starting from z=0 (surface)
@@ -562,6 +527,6 @@
 
 !
-!--    Determine u and v height levels considering the possibility of grid
-!--    stretching in several heights.
+!--    Determine u and v height levels considering the possibility of grid stretching in several
+!--    heights.
        n = 1
        dz_stretch_level_start_index = 0
@@ -570,38 +535,36 @@
 
        DO  k = nzt-1, 0, -1
-          
-          IF ( dz_stretch_level_start(n) >= zu(k+1) ) THEN
+
+          IF ( dz_stretch_level_start(n) >= zu(k+1) )  THEN
              dz_stretched = dz_stretched * dz_stretch_factor_array(n)
 
-             IF ( dz(n) > dz(n+1) ) THEN
+             IF ( dz(n) > dz(n+1) )  THEN
                 dz_stretched = MAX( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (higher) dz
              ELSE
                 dz_stretched = MIN( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (lower) dz
              ENDIF
-             
-             IF ( dz_stretch_level_start_index(n) == 0 )                             &
-             dz_stretch_level_start_index(n) = k+1
-             
-          ENDIF
-          
+
+             IF ( dz_stretch_level_start_index(n) == 0 )  dz_stretch_level_start_index(n) = k+1
+
+          ENDIF
+
           zu(k) = zu(k+1) - dz_stretched
-          
-!
-!--       Make sure that the stretching ends exactly at dz_stretch_level_end 
-          dz_level_end = ABS( zu(k) - dz_stretch_level_end(n) ) 
-          
-          IF ( dz_level_end  < dz(n+1)/3.0 ) THEN
+
+!
+!--       Make sure that the stretching ends exactly at dz_stretch_level_end
+          dz_level_end = ABS( zu(k) - dz_stretch_level_end(n) )
+
+          IF ( dz_level_end  < dz(n+1)/3.0 )  THEN
              zu(k) = dz_stretch_level_end(n)
              dz_stretched = dz(n+1)
              dz_stretch_level_end_index(n) = k
-             n = n + 1             
+             n = n + 1
           ENDIF
        ENDDO
-       
-!
-!--    Compute the w-levels. They are always staggered half-way between the 
-!--    corresponding u-levels, except in case of dirichlet bc for u and v
-!--    at the ground. In this case the first u- and w-level are defined at 
-!--    same height. The top w-level (nzt+1) is not used but set for 
+
+!
+!--    Compute the w-levels. They are always staggered half-way between the corresponding u-levels,
+!--    except in case of dirichlet bc for u and v at the ground. In this case the first u- and
+!--    w-level are defined at same height. The top w-level (nzt+1) is not used but set for
 !--    consistency, since w and all scalar variables are defined up tp nzt+1.
        zw(nzt+1) = dz(1)
@@ -612,6 +575,5 @@
 
 !
-!--    In case of dirichlet bc for u and v the first u- and w-level are defined
-!--    at same height.
+!--    In case of dirichlet bc for u and v the first u- and w-level are defined at same height.
        IF ( ibc_uv_b == 0 ) THEN
           zu(0) = zw(0)
@@ -632,11 +594,9 @@
        dd2zu(k) = 1.0_wp / ( dzu(k) + dzu(k+1) )
     ENDDO
-    
-!    
-!-- The FFT- SOR-pressure solvers assume grid spacings of a staggered grid
-!-- everywhere. For the actual grid, the grid spacing at the lowest level
-!-- is only dz/2, but should be dz. Therefore, an additional array
-!-- containing with appropriate grid information is created for these
-!-- solvers.
+
+!
+!-- The FFT- SOR-pressure solvers assume grid spacings of a staggered grid everywhere. For the
+!-- actual grid, the grid spacing at the lowest level is only dz/2, but should be dz. Therefore, an
+!-- additional array containing with appropriate grid information is created for these solvers.
     IF ( psolver(1:9) /= 'multigrid' )  THEN
        ALLOCATE( ddzu_pres(1:nzt+1) )
@@ -659,14 +619,13 @@
     topo = 0
 !
-!-- Initialize topography by generic topography or read topography from file.  
+!-- Initialize topography by generic topography or read topography from file.
     CALL init_topo( topo )
 !
-!-- Set flags to mask topography on the grid. 
+!-- Set flags to mask topography on the grid.
     CALL set_topo_flags( topo )
 
 !
-!-- Determine the maximum level of topography. It is used for
-!-- steering the degradation of order of the applied advection scheme, 
-!-- as well in the lpm.
+!-- Determine the maximum level of topography. It is used for steering the degradation of order of
+!-- the applied advection scheme, as well in the lpm.
     k_top = 0
     DO  i = nxl, nxr
@@ -678,6 +637,5 @@
     ENDDO
 #if defined( __parallel )
-    CALL MPI_ALLREDUCE( k_top, nzb_max, 1, MPI_INTEGER,                        &
-                        MPI_MAX, comm2d, ierr )
+    CALL MPI_ALLREDUCE( k_top, nzb_max, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )
 #else
     nzb_max = k_top
@@ -686,14 +644,14 @@
 !-- Increment nzb_max by 1 in order to allow for proper diverengence correction.
 !-- Further, in case topography extents up to the model top, limit to nzt.
-    nzb_max = MIN( nzb_max+1, nzt ) 
-!
-!-- Determine minimum index of topography. Usually, this will be nzb. In case
-!-- there is elevated topography, however, the lowest topography will be higher. 
-!-- This index is e.g. used to calculate mean first-grid point atmosphere 
-!-- temperature, surface pressure and density, etc. .
+    nzb_max = MIN( nzb_max+1, nzt )
+!
+!-- Determine minimum index of topography. Usually, this will be nzb. In case there is elevated
+!-- topography, however, the lowest topography will be higher.
+!-- This index is e.g. used to calculate mean first-grid point atmosphere temperature, surface
+!-- pressure and density, etc. .
     topo_min_level   = 0
 #if defined( __parallel )
-    CALL MPI_ALLREDUCE( MINVAL( topo_top_ind(nys:nyn,nxl:nxr,0) ),             &
-                        topo_min_level, 1, MPI_INTEGER, MPI_MIN, comm2d, ierr )
+    CALL MPI_ALLREDUCE( MINVAL( topo_top_ind(nys:nyn,nxl:nxr,0) ), topo_min_level, 1, MPI_INTEGER, &
+                        MPI_MIN, comm2d, ierr )
 #else
     topo_min_level = MINVAL( topo_top_ind(nys:nyn,nxl:nxr,0) )
@@ -701,11 +659,10 @@
 
 !
-!-- Check topography for consistency with model domain. Therefore, use
-!-- maximum and minium topography-top indices. Note, minimum topography top
-!-- index is already calculated.  
+!-- Check topography for consistency with model domain. Therefore, use maximum and minium
+!-- topography-top indices. Note, minimum topography top index is already calculated.
     IF ( TRIM( topography ) /= 'flat' )  THEN
 #if defined( __parallel )
-       CALL MPI_ALLREDUCE( MAXVAL( topo_top_ind(nys:nyn,nxl:nxr,0) ),          &
-                           nzb_local_max, 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )               
+       CALL MPI_ALLREDUCE( MAXVAL( topo_top_ind(nys:nyn,nxl:nxr,0) ), nzb_local_max, 1,            &
+                           MPI_INTEGER, MPI_MAX, comm2d, ierr )
 #else
        nzb_local_max = MAXVAL( topo_top_ind(nys:nyn,nxl:nxr,0) )
@@ -715,14 +672,13 @@
 !--    Consistency checks
        IF ( nzb_local_min < 0  .OR.  nzb_local_max  > nz + 1 )  THEN
-          WRITE( message_string, * ) 'nzb_local values are outside the',       &
-                                ' model domain',                               &
-                                '&MINVAL( nzb_local ) = ', nzb_local_min,      &
-                                '&MAXVAL( nzb_local ) = ', nzb_local_max
+          WRITE( message_string, * ) 'nzb_local values are outside the model domain',              &
+                                     '&MINVAL( nzb_local ) = ', nzb_local_min,                     &
+                                     '&MAXVAL( nzb_local ) = ', nzb_local_max
           CALL message( 'init_grid', 'PA0210', 1, 2, 0, 6, 0 )
        ENDIF
     ENDIF
 !
-!-- Define vertical gridpoint from (or to) which on the usual finite difference
-!-- form (which does not use surface fluxes) is applied 
+!-- Define vertical gridpoint from (or to) which on the usual finite difference form (which does not
+!-- use surface fluxes) is applied.
     IF ( constant_flux_layer  .OR.  use_surface_fluxes )  THEN
        nzb_diff = nzb + 2
@@ -733,18 +689,13 @@
     IF ( TRIM( topography ) /= 'flat' )  THEN
 !
-!--    Allocate and set the arrays containing the topography height (for output
-!--    reasons only).
+!--    Allocate and set the arrays containing the topography height (for output reasons only).
        IF ( nxr == nx  .AND.  nyn /= ny )  THEN
-          ALLOCATE( zu_s_inner(nxl:nxr+1,nys:nyn),                             &
-                    zw_w_inner(nxl:nxr+1,nys:nyn) )
+          ALLOCATE( zu_s_inner(nxl:nxr+1,nys:nyn), zw_w_inner(nxl:nxr+1,nys:nyn) )
        ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
-          ALLOCATE( zu_s_inner(nxl:nxr,nys:nyn+1),                             &
-                    zw_w_inner(nxl:nxr,nys:nyn+1) )
+          ALLOCATE( zu_s_inner(nxl:nxr,nys:nyn+1), zw_w_inner(nxl:nxr,nys:nyn+1) )
        ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
-          ALLOCATE( zu_s_inner(nxl:nxr+1,nys:nyn+1),                           &
-                    zw_w_inner(nxl:nxr+1,nys:nyn+1) )
+          ALLOCATE( zu_s_inner(nxl:nxr+1,nys:nyn+1), zw_w_inner(nxl:nxr+1,nys:nyn+1) )
        ELSE
-          ALLOCATE( zu_s_inner(nxl:nxr,nys:nyn),                               &
-                    zw_w_inner(nxl:nxr,nys:nyn) )
+          ALLOCATE( zu_s_inner(nxl:nxr,nys:nyn), zw_w_inner(nxl:nxr,nys:nyn) )
        ENDIF
 
@@ -752,18 +703,17 @@
        zw_w_inner   = 0.0_wp
 !
-!--    Determine local topography height on scalar and w-grid. Note, setting
-!--    lateral boundary values is not necessary, realized via wall_flags_static_0
-!--    array. Further, please note that loop bounds are different from
-!--    nxl to nxr and nys to nyn on south and right model boundary, hence,
+!--    Determine local topography height on scalar and w-grid. Note, setting lateral boundary values
+!--    is not necessary, realized via wall_flags_static_0 array. Further, please note that loop
+!--    bounds are different from nxl to nxr and nys to nyn on south and right model boundary, hence,
 !--    use intrinsic lbound and ubound functions to infer array bounds.
        DO  i = LBOUND(zu_s_inner, 1), UBOUND(zu_s_inner, 1)
           DO  j = LBOUND(zu_s_inner, 2), UBOUND(zu_s_inner, 2)
 !
-!--          Topography height on scalar grid. Therefore, determine index of
-!--          upward-facing surface element on scalar grid.
+!--          Topography height on scalar grid. Therefore, determine index of upward-facing surface
+!--          element on scalar grid.
              zu_s_inner(i,j) = zu(topo_top_ind(j,i,0))
 !
-!--          Topography height on w grid. Therefore, determine index of
-!--          upward-facing surface element on w grid.
+!--          Topography height on w grid. Therefore, determine index of upward-facing surface
+!--          element on w grid.
              zw_w_inner(i,j) = zw(topo_top_ind(j,i,3))
           ENDDO
